# ClusterMetadata

class `kafka.cluster.``ClusterMetadata`(**configs)

  A class to manage kafka cluster metadata.

  This class does not perform any IO. It simply updates internal state given API responses (MetadataResponse, GroupCoordinatorResponse).

  Keyword Arguments:
    retry_backoff_ms (int): Milliseconds to backoff when retrying on
      errors. Default: 100.
    metadata_max_age_ms (int): The period of time in milliseconds after
      which we force a refresh of metadata even if we haven’t seen any partition leadership changes to proactively discover any new brokers or partitions. Default: 300000
    bootstrap_servers: ‘host[:port]’ string (or list of ‘host[:port]’
      strings) that the client should contact to bootstrap initial cluster metadata. This does not have to be the full node list. It just needs to have at least one broker that will respond to a Metadata API Request. Default port is 9092. If no servers are specified, will default to localhost:9092.
  `add_group_coordinator`(group, response)

    Update with metadata for a group coordinator

    Arguments:
      group (str): name of group from GroupCoordinatorRequest response (GroupCoordinatorResponse): broker response
    Returns:
      bool: True if metadata is updated, False on error
  `add_listener`(listener)

    Add a callback function to be called on each metadata update

  `available_partitions_for_topic`(topic)

    Return set of partitions with known leaders

    Arguments:
      topic (str): topic to check for partitions
    Returns:
      set: {partition (int), …} None if topic not found.
  `broker_metadata`(broker_id)

    Get BrokerMetadata

    Arguments:
      broker_id (int): node_id for a broker to check
    Returns:
      BrokerMetadata or None if not found
  `brokers`()

    Get all BrokerMetadata

    Returns:
      set: {BrokerMetadata, …}
  `coordinator_for_group`(group)

    Return node_id of group coordinator.

    Arguments:
      group (str): name of consumer group
    Returns:
      int: node_id for group coordinator None if the group does not exist.
  `failed_update`(exception)

    Update cluster state given a failed MetadataRequest.

  `leader_for_partition`(partition)

    Return node_id of leader, -1 unavailable, None if unknown.

  `partitions_for_broker`(broker_id)

    Return TopicPartitions for which the broker is a leader.

    Arguments:
      broker_id (int): node id for a broker
    Returns:
      set: {TopicPartition, …} None if the broker either has no partitions or does not exist.
  `partitions_for_topic`(topic)

    Return set of all partitions for topic (whether available or not)

    Arguments:
      topic (str): topic to check for partitions
    Returns:
      set: {partition (int), …}
  `refresh_backoff`()

    Return milliseconds to wait before attempting to retry after failure

  `remove_listener`(listener)

    Remove a previously added listener callback

  `request_update`()

    Flags metadata for update, return Future()

    Actual update must be handled separately. This method will only change the reported ttl()

    Returns:
      kafka.future.Future (value will be the cluster object after update)
  `topics`(exclude_internal_topics=True)

    Get set of known topics.

    Arguments:
      exclude_internal_topics (bool): Whether records from internal topics
        (such as offsets) should be exposed to the consumer. If set to True the only way to receive records from an internal topic is subscribing to it. Default True
    Returns:
      set: {topic (str), …}
  `ttl`()

    Milliseconds until metadata should be refreshed

  `update_metadata`(metadata)

    Update cluster state given a MetadataResponse.

    Arguments:
      metadata (MetadataResponse): broker response to a metadata request

    Returns: None

  `with_partitions`(partitions_to_add)

    Returns a copy of cluster metadata with partitions added